package external

import "time"

type InfluxDB struct {
	ClientConfigs      map[string]*InfluxDBClientConfig      `json:"clientConfigs" yaml:"clientConfigs" toml:"clientConfigs"`
	BatchPointsConfigs map[string]*InfluxDBBatchPointsConfig `json:"batchPointsConfigs" yaml:"batchPointsConfigs" toml:"batchPointsConfigs"`
}

type InfluxDBClientConfig struct {
	ClientType string `json:"clientType" yaml:"clientType" toml:"clientType"`
	Address    string `json:"address" yaml:"address" toml:"address"`

	// Use HTTP Client
	Username  string        `json:"username" yaml:"username" toml:"username"`
	Password  string        `json:"password" yaml:"password" toml:"password"`
	UserAgent string        `json:"userAgent" yaml:"userAgent" toml:"userAgent"`
	Timeout   time.Duration `json:"timeout" yaml:"timeout" toml:"timeout"`

	// Use UDP Client
	PayloadSize int `json:"payloadSize" yaml:"payloadSize" toml:"payloadSize"`
}

type InfluxDBBatchPointsConfig struct {
	Precision        string `json:"precision" yaml:"precision" toml:"precision"`
	Database         string `json:"database" yaml:"database" toml:"database"`
	RetentionPolicy  string `json:"retentionPolicy" yaml:"retentionPolicy" toml:"retentionPolicy"`
	WriteConsistency string `json:"writeConsistency" yaml:"writeConsistency" toml:"writeConsistency"`
}
