package target

import (
	"encoding/json"

	"git.loafle.net/overflow/commons-go/core/util"
	"git.loafle.net/overflow/commons-go/model/infra"
	"git.loafle.net/overflow/commons-go/model/meta"
	"git.loafle.net/overflow/commons-go/model/sensor"
)

type Target struct {
	ID             json.Number          `json:"id,Number,omitempty"`
	Infra          *infra.Infra         `json:"infra,omitempty"`
	MetaTargetType *meta.MetaTargetType `json:"metaTargetType,omitempty"`
	Name           string               `json:"name,omitempty"`
	Description    string               `json:"description,omitempty"`
	SensorCount    json.Number          `json:"sensorCount,omitempty"`
	CreateDate     *util.Timestamp      `json:"createDate,omitempty"`
	Sensors        []*sensor.Sensor     `json:"sensors,omitempty"`
}
